C*********************************************************************
C
C     PROGRAM xzcont_ptm_3
C
C     x-zʿ޺ץ(, )
C
C      1997/07/24 
C          1997/07/25 
C          1997/07/26 
C          1997/07/26 
C          1998/09/17 
C          1998/10/02 
C          1999/01/10 
C          1999/02/04 
C          1999/02/07 
C
C*********************************************************************
      program xzcont_ptm_3
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )

      parameter ( ixmin = 250, ixmax = 350 )
      parameter ( izmin = 1, izmax = 105 )

C      parameter ( ixmin = 270, ixmax = 290 )
C      parameter ( izmin = 1, izmax = 25 )


      real*8
     \   zgrid ( -2:nzb ),temp0 ( -2:nzb ),tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),ppai0 ( -2:nzb ),pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      real*8
     \     tpot ( -2:nxb, -2:nzb ), ttpot ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), p0p ( 0:nz ),    d0p ( 0:nz ),
     \ temp0p ( 0:nz ), tpot0p ( 0:nz ), pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ), qvap0p ( 0:nz )

      real*4 
     \      tpotp ( nx+1, nz+1 ), tpall ( nx+1, nz+1 ),
     \      tpave ( nz+1 ),       tpdev ( nx+1, nz+1 )

      character*2 mint, lt, date
      character*17 header

*-----------------------------------------------------
      real*4 xvpt, yvpt
      real*4 tpdev_p(ixmax-ixmin+1, izmax-izmin+1)
*-----------------------------------------------------
      parameter ( nzprof = nz )                              
      parameter ( nzp = nz+1, ntp = 120 )

      character*5  nmrun
      character*4  from
      character*1  chara
      character*1  pz

      real*4  dtpad0,dqvad0
      real*4  zp(nzp)    ,tptend(nzp),tpmean(nzp),
     &        dtpadv(nzp),dtpdif(nzp),dtpdnl(nzp), 
     &        dtpdi0(nzp),dtprad(nzp),
     &        tperror(nzp),dtirad(nzp),dtsrad(nzp)

      real*4 itime(100), heat(100)
      real*4 sflux_h, tinterv

      integer fnum, begin, end, interv, nloop1

C=====================================================================  

      xvpt = 0.05
      yvpt = 0.4

      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als
      close(11)

      tinterv = nloop2 * ( dtime / 2. )

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = REAL(zgrid(iz))/1000.0
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      iflag = 0

      call sgpwsn
      read(*,*) iws

      call gropn(iws)
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call uzfact(0.5)
      call udlset( 'LMSG', .FALSE. )
*
      do it = 1, ite

      read(34) time, ((tpot(ix,iz),ix=-2,nxb), iz=-2,nzb)

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

c*** Ѵ: ä LT ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

C            header = 'day=' // date // ' ' // 'LT=' // lt // ':' // mint
            header = 'LT=' // lt // ':' // mint
c**************************************************************

!- rm 2-grid noize ----------------------------------------------------

            do iz = -2,nzb
            do ix = 0,nx
               ttpot(ix,iz) = ( tpot(ix-1,iz) + 2.0*tpot(ix,iz)
     \                        + tpot(ix+1,iz) ) / 4.0 
            end do
            end do

            do iz = -2,NZB
               ttpot(-2,iz)  = tpot(nx-2,iz) 
               ttpot(-1,iz)  = tpot(nx-1,iz) 
               ttpot(0,iz)   = tpot(nx,iz) 
               ttpot(nx+1,iz)= tpot(1,iz) 
               ttpot(nx+2,iz)= tpot(2,iz) 
            end do

            do iz = -2,nzb
            do ix = -2,nxb
               tpot(ix,iz) = ttpot(ix,iz)
            end do
            end do

!- rm 2-grid noize ----------------------------------------------------

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpotp(ix,iz) = tpot(ix-1,iz-1)
                  tpall(ix,iz) = tpot(ix-1,iz-1) + tpot0(iz-1)
               end do
            end do
*
            do iz = 1, nz+1
               tpave(iz) = 0.
               do ix = 1,nx+1
                  tpave(iz) = tpave(iz) + tpall(ix,iz) /(nx+1)
               end do
            end do

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpdev(ix,iz) = tpall(ix,iz) - tpave(iz) 
               end do
            end do

            do iz = 1, izmax-izmin+1
               do ix = 1, ixmax-ixmin+1
                  tpdev_p(ix,iz) = tpdev(ix+ixmin-1,iz+izmin-1)
               end do
            end do

            if ( MOD(iflag,3) .eq. 0) then
               xvpt = 0.05
            end if

            if ( iflag .eq. 0 ) then
               call grfrm
            else
               call grfig
            end if

C            call grswnd ( 0.0, 2.0, 0.0, 2.0 )
            call grswnd ( 0.0, 10.0, 0.0, 10.0 )

            if ( iflag .lt. 3 ) then 
               call grsvpt ( xvpt, xvpt+0.2, 0.65, 0.85 )
            else if ( iflag .lt. 6 ) then 
               call grsvpt ( xvpt, xvpt+0.2, 0.37, 0.57 )
            else
               call grsvpt ( xvpt, xvpt+0.2, 0.10, 0.30 )
            end if   

            call grstrn (1)
            call uspfit
            call grstrf
            call udpset ( 'rsizet', 0.01 )
            call udpset ( 'ICYCLE', 2 )
            call uwsgya ( z0p, izmax-izmin+1 )
            call uestlv ( -10., 0., 603)
            call uetone ( tpdev_p, 
     \           ixmax-ixmin+1, ixmax-ixmin+1, izmax-izmin+1 )
            call ueitlv

            if ( MOD(iflag,3) .eq. 0 ) then
               call ussttl ( '', 'X[km]', '', 'Z[km]' )
               call usdaxs
            else
               call ussttl ( '', 'X[km]', '', '' )
               call usdaxs
            end if

            call udgcla ( -10., 10., 1. )

            call udcntz ( tpdev(ixmin,izmin), 
     \           nx+1, ixmax-ixmin+1, izmax-izmin+1, ibr, nbr3 )
            call uxsttl ( 'T', header, 1. )
            call uzinit
*
*
            xvpt = xvpt + 0.23
            iflag = iflag + 1

         end if
      end if

      end do

      call grcls
      call FCLOSE

      end

